#include "jtag.h"
#include "system.h"


#define BYPASS_DCACHE   (0x1 << 31)

#define JTAGUARTDAT     (*(volatile unsigned int*)((JTAGUART_BASE+0x0) | BYPASS_DCACHE))
#define JTAGUARTCNT     (*(volatile unsigned int*)((JTAGUART_BASE+0x4) | BYPASS_DCACHE))

#define JTAGUART_WSPACE (65535<<16)


void JTAG_Write(const unsigned char* data, unsigned int count)
{
    while(count)
    {
        unsigned int wspace = JTAGUARTCNT >> 16;
        
        if (wspace)
        {
            JTAGUARTDAT = *data++;
            
            count--;
        }
    }
}





