#include "printf.h"
#include "system.h"


#define BYPASS_DCACHE   (0x1 << 31)

#define JTAGUARTDAT     (*(volatile unsigned int*)((JTAGUART_BASE+0x0) | BYPASS_DCACHE))
#define JTAGUARTCNT     (*(volatile unsigned int*)((JTAGUART_BASE+0x4) | BYPASS_DCACHE))

#define JTAGUART_RVALID (1<<15)

#define DSUARTRXCNT        (*(volatile unsigned int*)((DSUART_BASE+0x0) | BYPASS_DCACHE))
#define DSUARTTXCNT        (*(volatile unsigned int*)((DSUART_BASE+0x4) | BYPASS_DCACHE))

#define DSUART_FULL       (1<<8)
#define DSUART_ACK         1       


int main()
{
    printf("Hello world!\n");
    
    
    for(;;)
    {
        unsigned int dsrxcontrol = DSUARTRXCNT;
        unsigned int dstxcontrol = DSUARTTXCNT;
        
        
        if (dsrxcontrol & DSUART_FULL)
        {
            unsigned int wspace = JTAGUARTCNT >> 16;    
        
            if (wspace)
            {
                JTAGUARTDAT = dsrxcontrol & 0xFF;
                
                DSUARTRXCNT = DSUART_ACK;
            }
        }
        
        if (!(dstxcontrol & DSUART_FULL))
        {
            unsigned int jtagdata = JTAGUARTDAT;
        
            if (jtagdata & JTAGUART_RVALID)
            {
                DSUARTTXCNT = jtagdata & 0xFF;           
            }
        }
    }

    return 0;
}

